unit DspSetup;
{$IFNDEF DEBUG}
{$A+,B-,D-,F-,G+,I-,K+,L-,N+,P+,Q-,R-,S-,T+,V-,W-,X+,Y-}
{$ENDIF}

interface
uses
    SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
    Forms, Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TDspSetupForm = class(TForm)
    BevelHi: TBevel;
    BevelLo: TBevel;
    LoadPanel: TPanel;
    DspPanel: TPanel;
    AutoLoadBiosCB: TCheckBox;
    OldStyleCB:TCheckBox;
    NoDslCB: TCheckBox;
    BiosNameE: TEdit;
    BiosNameLab: TLabel;
    DSPTypeRG: TRadioGroup;
    WaitStateE: TEdit;
    WaitStateLab: TLabel;
    InterDelayE: TEdit;
    InterDelayLab: TLabel;
    BrowseBtn: TButton;
    ApplyBtn: TBitBtn;
    OkBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    OpenBIOSDialog: TOpenDialog;
    DefaultBtn: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure AutoLoadBiosCBClick(Sender: TObject);
    procedure BiosNameEChange(Sender: TObject);
    procedure OldStyleCBClick(Sender: TObject);
    procedure NoDslCBClick(Sender: TObject);
    procedure DSPTypeRGClick(Sender: TObject);
    procedure WaitStateEChange(Sender: TObject);
    procedure InterDelayEChange(Sender: TObject);
    procedure BrowseBtnClick(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure ApplyBtnClick(Sender: TObject);
    procedure DefaultBtnClick(Sender: TObject);
    procedure WaitStateEKeyPress(Sender: TObject; var Key: Char);
    procedure InterDelayEKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetLanguage;
    procedure ShowAllVariable;
  end;

var
   DspSetupForm: TDspSetupForm;

implementation
{$R *.DFM}
uses
    SetupMn, Ini, LUtil, GlobVar, LCard_AD;

{* ************************************************************************* *}
procedure TDspSetupForm.SetLanguage;
Begin
    DspSetupForm.Caption   :=MyLoadStr(DspSetupFormCaption);

    LoadPanel.Caption      :=MyLoadStr(LoadPanelCaption);
    DspPanel.Caption       :=MyLoadStr(DspPanelCaption);

    AutoLoadBiosCB.Caption :=MyLoadStr(AutoLoadBiosCBCaption);
    AutoLoadBiosCB.Hint    :=MyLoadStr(AutoLoadBiosCBHint);
    OldStyleCB.Caption     :=MyLoadStr(OldStyleCBCaption);
    OldStyleCB.Hint        :=MyLoadStr(OldStyleCBHint);
    NoDslCB.Caption        :=MyLoadStr(NoDslCBCaption);
    NoDslCB.Hint           :=MyLoadStr(NoDslCBHint);

    DSPTypeRG.Caption      :=MyLoadStr(DSPTypeRGCaption);
    DSPTypeRG.Hint         :=MyLoadStr(DSPTypeRGHint);

    BiosNameLab.Caption    :=MyLoadStr(BiosNameLabCaption);
    BiosNameE.Hint         :=MyLoadStr(BiosNameEHint);
    WaitStateLab.Caption   :=MyLoadStr(WaitStateLabCaption);
    WaitStateE.Hint        :=MyLoadStr(WaitStateEHint);
    InterDelayLab.Caption  :=MyLoadStr(InterDelayLabCaption);
    InterDelayE.Hint       :=MyLoadStr(InterDelayEHint);

    BrowseBtn.Caption      :=MyLoadStr(BrowseBtnCaption);
    BrowseBtn.Hint         :=MyLoadStr(BrowseBtnHint);
    ApplyBtn.Caption       :=MyLoadStr(ApplyBtnCaption);
    ApplyBtn.Hint          :=MyLoadStr(ApplyBtnHint);
    OkBtn.Caption          :=MyLoadStr(OkBtnCaption);
    OkBtn.Hint             :=MyLoadStr(OkBtnHint);
    CancelBtn.Caption      :=MyLoadStr(CancelBtnCaption);
    CancelBtn.Hint         :=MyLoadStr(CancelBtnHint);
    HelpBtn.Caption        :=MyLoadStr(HelpBtnCaption);
    HelpBtn.Hint           :=MyLoadStr(HelpBtnHint);
    DefaultBtn.Caption     :=MyLoadStr(DefaultBtnCaption);
    DefaultBtn.Hint        :=MyLoadStr(DefaultBtnHint);

    OpenBIOSDialog.Title   :=MyLoadStr(OpenBIOSDialogTitle);
    OpenBIOSDialog.Filter  :=MyLoadStr(OpenBIOSDialogFilter);

End;

{* ************************************************************************* *}
{                    }
{* ************************************************************************* *}
procedure TDspSetupForm.ShowAllVariable;
var
    s:string;

begin
    with ThisSlot do
    Begin
        AutoLoadBiosCB.Checked:=AutoLoadBios;
        BiosNameE.Text        :=BiosName;
        OldStyleCB.Checked    :=BIOS_IsOldStyle;
        NoDslCB.Visible       :=BIOS_IsOldStyle;
        NoDslCB.Checked       :=NoDSL;
        DspTypeRG.ItemIndex   :=DspType;
        Str(InterDelay/10:1:2, s);
        InterDelayE.Text      :=s;
        InterDelayLab.Visible :=True;
        InterDelayE.Visible   :=True;
        WaitStateE.Text       :=IntToStr(WaitState);
        WaitStateLab.Visible  :=True;
        WaitStateE.Visible    :=True;

        case BoardType of
            LCI01:
            Begin
                InterDelayE.Visible:=False;
                InterDelayLab.Visible:=False;
                WaitStateE.Visible :=False;
                WaitStateLab.Visible :=False;
            End;
        else
        End;
    End;
end;

{* ************************************************************************* *}
procedure TDspSetupForm.WaitStateEKeyPress(Sender: TObject; var Key: Char);
begin
    if not (Key in [#8, '0'..'9']) then Key:=#27;
end;

{* ************************************************************************* *}
procedure TDspSetupForm.InterDelayEKeyPress(Sender: TObject; var Key: Char);
begin
    case Key of
        '.': if Pos('.', InterDelayE.Text)<>0 then Key:=#27;
        #8, '0'..'9':;
    else
        Key:=#27;
    End;
end;

{* ************************************************************************* *}
{                                                       }
{* ************************************************************************* *}
procedure TDspSetupForm.FormActivate(Sender: TObject);
begin
    DefaultBtnClick(Sender);
    SetLanguage;
end;

{* ************************************************************************* *}
procedure TDspSetupForm.AutoLoadBiosCBClick(Sender: TObject);
begin
    ThisSlot.AutoLoadBIOS:=AutoLoadBiosCB.Checked;
    ApplyBtn.Enabled:=SlotCompare;
end;

{* ************************************************************************* *}
{   Browse    BIOS                                  }
{* ************************************************************************* *}
procedure TDspSetupForm.BrowseBtnClick(Sender: TObject);
var
    i:word;

begin
    OpenBIOSDialog.InitialDir:=ExtractFilePath(ThisSlot.BiosName);
    for i:=FirstBoard to LastBoard do if DefaultBiosName[i]<>'' then OpenBIOSDialog.HistoryList.Add(DefaultBiosName[i]);
    if OpenBIOSDialog.Execute then
    Begin
        DefaultBIOSName[ThisSlot.BoardType]:=ExpandFileName(OpenBIOSDialog.FileName);
        BiosNameE.Text:=ChangeFileExt(DefaultBIOSName[ThisSlot.BoardType], '');
    End;
end;

{* ************************************************************************* *}
procedure TDspSetupForm.BiosNameEChange(Sender: TObject);
begin
    OldStyleCB.Checked:=ExtractFileExt(DefaultBIOSName[ThisSlot.BoardType])='.BIN';
    ThisSlot.BiosName:=BiosNameE.Text;
    ApplyBtn.Enabled:=SlotCompare;
end;

{* ************************************************************************* *}
{                                        }
{* ************************************************************************* *}
procedure TDspSetupForm.OldStyleCBClick(Sender: TObject);
begin
    ThisSlot.Bios_IsOldStyle:=OldStyleCB.Checked;
    ApplyBtn.Enabled:=SlotCompare;
    ShowAllVariable;
end;

{* ************************************************************************* *}
procedure TDspSetupForm.NoDslCBClick(Sender: TObject);
begin
    ThisSlot.NoDSL:=NoDslCB.Checked;
    ApplyBtn.Enabled:=SlotCompare;
end;

{* ************************************************************************* *}
procedure TDspSetupForm.DSPTypeRGClick(Sender: TObject);
begin
    ThisSlot.DSPType:=DspTypeRG.ItemIndex;
    ApplyBtn.Enabled:=SlotCompare;
end;

{* ************************************************************************* *}
procedure TDspSetupForm.WaitStateEChange(Sender: TObject);
begin
    if WaitStateE.Text<>'' then ThisSlot.WaitState:=Word(StrToInt(WaitStateE.Text)) else ThisSlot.WaitState:=0;
    ApplyBtn.Enabled:=SlotCompare;
    ShowAllVariable;
end;

{* ************************************************************************* *}
procedure TDspSetupForm.InterDelayEChange(Sender: TObject);
var
    r:real;
    i:integer;

begin
    Val(InterDelayE.Text, r, i);
    ThisSlot.InterDelay:=Word(Round(r*10));
    ApplyBtn.Enabled:=SlotCompare;
    ShowAllVariable;
end;

{* ************************************************************************* *}
procedure TDspSetupForm.ApplyBtnClick(Sender: TObject);
begin
    SlotArray[CurrSlot]:=ThisSlot;
    if ChangeFileExt(DefaultBIOSName[ThisSlot.BoardType], '')<>ThisSlot.BiosName then
        DefaultBIOSName[ThisSlot.BoardType]:=ThisSlot.BiosName+ExtractFileExt(DefaultBIOSName[ThisSlot.BoardType]);
    WriteIniSettings;
    ApplyBtn.Enabled:=SlotCompare;
    ShowAllVariable;
end;

{* ************************************************************************* *}
{      OK                                                 }
{* ************************************************************************* *}
procedure TDspSetupForm.OkBtnClick(Sender: TObject);
begin
    ApplyBtnClick(Sender);
    CancelBtnClick(Sender);
end;

{* ************************************************************************* *}
{      Cancel                                             }
{* ************************************************************************* *}
procedure TDspSetupForm.CancelBtnClick(Sender: TObject);
begin
    Close;
end;

{* ************************************************************************* *}
procedure TDspSetupForm.DefaultBtnClick(Sender: TObject);
begin
    ThisSlot:=SlotArray[CurrSlot];
    ApplyBtn.Enabled:=SlotCompare;
    ShowAllVariable;
end;

end.

