unit GlobVar;
{$IFNDEF DEBUG}
{$A+,B-,D-,F-,G+,I-,K+,L-,N+,P+,Q-,R-,S-,T+,V-,W-,X+,Y-}
{$ENDIF}

interface
uses
    LCard_AD;

const
    MaxSlotArray=15;
    FirstBoard=NO_BOARD;
    LastBoard =Unknown;
    ADSPBoards=[L305, L1610, L1250, L1056, L1208, L264, E330, L1210,
                LCI01, CRAIT, L1211, L1620, L1221, L750, Unknown];

    Multi     :word=$8000;
    CurrSlot  :word=0;
    BoardNames:array[FirstBoard..LastBoard] of string[7]=
        ('None',
         'L305','L1610','L1250',
         'L154','L164',
         'L1056','L1208','L264',
         'E330',
         'L1210',
         'LCI01',
         'Crait',
         'L241',
         'L1211', 'L1620', 'L1221',
         'L750',
         'Unknown'
        );

    BiosNames:array[FirstBoard..LastBoard] of string[12]=
        ('(None)',
         'LBIOS11.BIN','LBIOS002.BIN','LBIOS009.BIN',
         '(None)','(None)',
         'LBIOS005.BIN','LBIOS10.BIN','LBIOS12.BIN',
         'LB_WIN20.BIO',
         'LBIOS003.BIN',
         'LCI01.BIO',
         'LC_014.BIO',
         '(None)',
         'LBIOS013.BIO', 'LBIOS015.BIN', 'LBIOS016.BIO',
         'LBIOS750.BIO',
         '(None)'
        );

    FirstInterface=EPP_INTERFACE;
    LastInterface =BIDIR_INTERFACE;

    InterfaceNames:array[FirstInterface..LastInterface+2] of string[20]=
        ('EPP (LPT)',
         'Manchester',
         'Bidirectional (LPT)',
         'IDE',
         'Serial (COM)'
        );

    Reserved_0             =$0000;
    BindingCBItems         =$0001;

    FirstPanelCaption      =$0002;
    LWinPanelCaption       =$0003;
    CommonPanelCaption     =$0004;
    PlatyPanelCaption      =$0005;

    SlotTSTabs             =$0006;
    SlotTSHint             =$0007;

    TypeLabCaption         =$0008;
    TypeCBHint             =$0009;
    BaseLabCaption         =$000A;
    BaseCBHint             =$000B;
    IrqLabCaption          =$000C;
    IrqCBHint              =$000D;
    InterfaceLabCaption    =$000E;
    InterfaceCBHint        =$000F;
    BindingLabCaption      =$0010;
    BindingCBHint          =$0011;

    CraitAddressLabCaption =$0012;
    CraitAddressEHint      =$0013;

    IntEnabledCBCaption    =$0014;
    IntEnabledCBHint       =$0015;
    IgnoreErrorCBCaption   =$0016;
    IgnoreErrorCBHint      =$0017;

    DspSetupBtnCaption     =$0018;
    DspSetupBtnHint        =$0019;
    TestBtnCaption         =$001A;
    TestBtnHint            =$001B;
    OkBtnCaption           =$001C;
    OkBtnHint              =$001D;
    CancelBtnCaption       =$001E;
    CancelBtnHint          =$001F;
    HelpBtnCaption         =$0020;
    HelpBtnHint            =$0021;

    LoadPanelCaption       =$0022;
    DspPanelCaption        =$0023;

    AutoLoadBiosCBCaption  =$0024;
    AutoLoadBiosCBHint     =$0025;
    OldStyleCBCaption      =$0026;
    OldStyleCBHint         =$0027;
    NoDslCBCaption         =$0028;
    NoDslCBHint            =$0029;

    DSPTypeRGCaption       =$002A;
    DSPTypeRGHint          =$002B;

    BiosNameLabCaption     =$002C;
    BiosNameEHint          =$002D;
    WaitStateLabCaption    =$002E;
    WaitStateEHint         =$002F;
    InterDelayLabCaption   =$0030;
    InterDelayEHint        =$0031;

    BrowseBtnCaption       =$0032;
    BrowseBtnHint          =$0033;
    ApplyBtnCaption        =$0034;
    ApplyBtnHint           =$0035;

    SetupFormCaption       =$0036;
    DspSetupFormCaption    =$0037;

    SaveChangesConfirmation=$0038;
    Reserved_1             =$0039;

    DefaultBtnCaption      =$003A;
    DefaultBtnHint         =$003B;

    OpenBIOSDialogTitle    =$003C;
    OpenBIOSDialogFilter   =$003D;

    TestBoardFormCaption   =$003E;
    ChanSBHint             =$003F;
    ChanLabCaption         =$0040;
    ChanEHint              =$0041;
    TestPanelCaption       =$0042;
    RateSBHint             =$0043;
    RateLabCaption         =$0044;
    RateEHint              =$0045;
    InputModeRGCaption     =$0046;
    InputModeRGHint        =$0047;

    TestLCIFormCaption     =$0048;
    TestLCIPanelCaption    =$0049;

    TestLTCFormCaption     =$004A;
    TestLTCPanelCaption    =$004B;
    MemoryStateLabCaption  =$004C;
    MemoryStateEHint       =$004D;
    MemoryPMStateLabCaption=$004E;
    MemoryPMStateEHint     =$004F;

    ModuleListBoxItemsL    =$0050;
    ModuleListBoxItemsR    =$0051;

type
    Slot=record
        {   }
        BoardType      :word;
        BoardBase      :longint;
        BoardIrq       :word;
        BoardInterface :word;
        Binding        :word;
        CraitAddress   :word;
        DSPType        :word;
        WaitState      :word;
        InterDelay     :word;
        BIOSName       :string;
        AutoLoadBios   :boolean;
        NoDSL          :boolean;
        BIOS_IsOldStyle:boolean;
    End;

const
    SlotSize=SizeOf(Slot);

var
    {   }
    MaxSlot    :word;
    Language   :boolean;
    IntEnabled :boolean;
    IgnoreError:boolean;
    NeedLog    :boolean;
    NeedLogIO  :boolean;

    {    }
    SlotArray      :array[0..MaxSlotArray] of Slot;
    DefaultBIOSName:array[FirstBoard..LastBoard] of string;

    ThisSlot       :Slot;
    ErrorOccurred  :boolean;
    ThisIntEnabled :boolean;
    ThisIgnoreError:boolean;

implementation
{$R ERROR}

End.

