unit Lbios;
{$IFNDEF DEBUG}
{$A+,B-,D-,F-,G+,I-,K+,L-,N+,P+,Q-,R-,S-,T+,V-,W-,X+,Y-}
{$ENDIF}

interface

function LoadBoardBios:boolean;

implementation
uses
    Forms, GlobVar, Lcard_ad, SysUtils, WinTypes, WinProcs;

const
    dmModeValue=$7019;

{* ************************************************************************* *}
{  BIOS   -
{* ************************************************************************* *}
function LoadBoardBios:boolean;
var
    pBIOSName     :array [0..255] of char;
    S             :string;
    p             :array [0..1024] of char;
    LbResult      :integer;
    ThisDeviceNum :integer;
    ThisDeviceBind:integer;

Begin
    with SlotArray[CurrSlot] do
    Begin
        case BoardType of

            E330:
            Begin
                SELECT_DEVICE(CurrSlot);
                SET_BOARD_TYPE(BoardType);
                SET_BASE_ADDRESS(BoardBase);
                INTR_SETUP(BoardIrq);
                SET_INTERFACE_TYPE(BoardInterface);
                BIOSName[Length(BIOSName)+1]:=#0;
                Result:=LOADBIOS((@BIOSName[1])^, 0)=0;
                if Result then
                Begin
                    BOARD_SPECIFIC_INIT(0);
                    if PLATA_TEST<>0 then
                    Begin
                        Result:=False;
                    End else
                    Begin
                        SET_ADSP_SPEED(DSPType);
                        SET_WAIT_STATE(WaitState);
                        SET_INTER_DELAY(InterDelay);
                        SET_TIMER_SCALE(10);
                    End;
                End;
                Exit;
            End;

            L750:
            Begin
                SELECT_DEVICE(CurrSlot);
                SET_BOARD_TYPE(BoardType);
                RESET_DSP_L750;
                PUT_DM_WORD_L750(dmModeValue, $5555);
                if GET_DM_WORD_L750(dmModeValue)<>$5555 then Result:=False else
                Begin
                    BIOSName[Length(BIOSName)+1]:=#0;
                    Result:=LOADBIOS((@BIOSName[1])^, integer(NoDsl))=0;
                    if Result then
                    Begin
                        BOARD_SPECIFIC_INIT(0);
                        Result:=PLATA_TEST=0;
                    End;
                End;
                Exit;
            End;

            LCI01:
            Begin
                SELECT_DEVICE(CurrSlot);
                SET_BOARD_TYPE(BoardType);
                SET_BASE_ADDRESS(BoardBase);
                INTR_SETUP(BoardIrq);
                BIOSName[Length(BIOSName)+1]:=#0;
                Result:=LOADBIOS((@BIOSName[1])^, word(NoDsl))=0;
                if Result then
                Begin
                    BOARD_SPECIFIC_INIT(0);
                    Result:=PLATA_TEST=0;
                End;
                Exit;
            End;

            CRAIT:
            Begin
                SELECT_DEVICE(CurrSlot);
                SET_BOARD_TYPE(BoardType);
                SET_INTERFACE_TYPE(BoardInterface);
                SET_CRAIT_ADDRESS(CraitAddress);
                SET_DEVICE_BINDING(Binding);
                BIOSName[Length(BIOSName)+1]:=#0;
                Result:=LOADBIOS((@BIOSName[1])^, integer(NoDsl))=0;
                if Result then
                Begin
                    BOARD_SPECIFIC_INIT(0);
                    Result:=PLATA_TEST=0;
                End;
                Exit;
            End;

            L154,
            L164:
            Begin
                SELECT_DEVICE(CurrSlot);
                SET_BOARD_TYPE(BoardType);
                SET_BASE_ADDRESS(BoardBase);
                INTR_SETUP(BoardIrq);
                Result:=PLATA_TEST=0;
                Exit;
            End;

        else
            Begin
                SELECT_DEVICE(CurrSlot);
                SET_BOARD_TYPE(BoardType);
                SET_BASE_ADDRESS(BoardBase);
                INTR_SETUP(BoardIrq);
                BIOSName[Length(BIOSName)+1]:=#0;
                Result:=LOADBIOS((@BIOSName[1])^, integer(NoDsl))=0;
                if Result then
                Begin
                    BOARD_SPECIFIC_INIT(0);
                    if PLATA_TEST<>0 then
                    Begin
                        Result:=False;
                    End else
                    Begin
                        SET_ADSP_SPEED(DSPType);
                        SET_WAIT_STATE(WaitState);
                        SET_INTER_DELAY(InterDelay);
                    End;
                End;
                Exit;
            End;
        End;
    End;
End;

End.

