unit LUtil;
{$IFNDEF DEBUG}
{$A+,B-,D-,F-,G+,I-,K+,L-,N+,P+,Q-,R-,S-,T+,V-,W-,X+,Y-}
{$ENDIF}

interface

function MyLoadStr(Ident:word):string;
function StringToWord(const FromString:string; var ToWord:word; Error:word; HelpCtx:Longint):boolean;
function InitStringToWord(const FromString:string; var ToWord:word; DefaultWord:word):boolean;
function StringToLongint(const FromString:string; var ToLongint:Longint; Error:word; HelpCtx:Longint):boolean;
function InitStringToLongint(const FromString:string; var ToLongint:Longint; DefaultLongint:Longint):boolean;
function SlotCompare:boolean;

implementation
uses
    SysUtils, Dialogs, GlobVar;

{* ************************************************************************* *}
function MyLoadStr(Ident:word):string;
Begin
    MyLoadStr:=LoadStr(Ident+Multi)
End;

{* ************************************************************************* *}
function StringToWord(const FromString:string; var ToWord:word; Error:word; HelpCtx:Longint):boolean;
var
    s:string;

Begin
    try
        ToWord:=Abs(StrToInt(FromString));
        StringToWord:=True;
    except
        on EConvertError do
        Begin
            if Error<>$FFFF then
            Begin
                s:=MyLoadStr(Error);
                if s='' then MessageDlg(#13'Resource String Not Found.', mtError, [mbOk], 0)
                        else MessageDlg(Format(s, [FromString]), mtError, [mbOk], HelpCtx);
                StringToWord:=False;
            End;
        End;
    End;
End;

{* ************************************************************************* *}
function InitStringToWord(const FromString:string; var ToWord:word; DefaultWord:word):boolean;
Begin
    ToWord:=DefaultWord;
    InitStringToWord:=StringToWord(FromString, ToWord, $FFFF, 0);
End;

{* ************************************************************************* *}
function StringToLongint(const FromString:string; var ToLongint:Longint; Error:word; HelpCtx:Longint):boolean;
var
    s:string;

Begin
    try
        ToLongint:=StrToInt(FromString);
        StringToLongint:=True;
    except
        on EConvertError do
        Begin
            if Error<>$FFFF then
            Begin
                s:=MyLoadStr(Error);
                if s='' then MessageDlg(#13'Resource String Not Found.', mtError, [mbOk], 0)
                        else MessageDlg(Format(s, [FromString]), mtError, [mbOk], HelpCtx);
                StringToLongint:=False;
            End;
        End;
    End;
End;

{* ************************************************************************* *}
function InitStringToLongint(const FromString:string; var ToLongint:Longint; DefaultLongint:Longint):boolean;
Begin
    ToLongint:=DefaultLongint;
    InitStringToLongint:=StringToLongint(FromString, ToLongint, $FFFF, 0);
End;

{* ************************************************************************* *}
function SlotCompare:boolean;assembler;
asm
    cld
    push ds
    mov  ax, CurrSlot
    mov  cx, SlotSize
    pop  es
    mul  cx
    mov  di, offset SlotArray
    add  di, ax

    mov  al, True
    mov  si, offset ThisSlot
    rep  cmpsb
    jnz  @

    mov  ah, IntEnabled
    cmp  ah, ThisIntEnabled
    jnz  @

    mov  ah, IgnoreError
    cmp  ah, ThisIgnoreError
    jnz  @

    sub  al, al
@:
End;

End.

