unit SetupMn;
{$IFNDEF DEBUG}
{$A+,B-,D-,F-,G+,I-,K+,L-,N+,P+,Q-,R-,S-,T+,V-,W-,X+,Y-}
{$ENDIF}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons, IniFiles,
  Tabs, Menus;

type
  TSetupForm = class(TForm)
    BevelLO: TBevel;
    BevelHI: TBevel;
    LanguageBtn: TButton;

    FirstPanel: TPanel;
    LWinPanel: TPanel;
    CommonPanel: TPanel;
    PlatyPanel: TPanel;

    SlotTS: TTabSet;

    TypeCB: TComboBox;
    TypeLab: TLabel;
    BaseCB: TComboBox;
    BaseLab: TLabel;
    IrqCB: TComboBox;
    IrqLab: TLabel;
    InterfaceCB: TComboBox;
    InterfaceLab: TLabel;
    BindingCB: TComboBox;
    BindingLab: TLabel;

    CraitAddressE: TEdit;
    CraitAddressLab: TLabel;

    IntEnabledCB: TCheckBox;
    IgnoreErrorCB: TCheckBox;

    DspSetupBtn: TBitBtn;
    TestBtn: TBitBtn;
    OkBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TButton;
    ApplyBtn: TBitBtn;
    DefaultBtn: TBitBtn;

    TestTimer: TTimer;
    AboutPopupMenu: TPopupMenu;
    About: TMenuItem;
    MenuPopupPanel: TPanel;
    AdvancedPopupMenu: TPopupMenu;
    SetIgnoreError: TMenuItem;
    SetTimeout: TMenuItem;
    SetDelay1mks: TMenuItem;
    SetupMnImage: TImage;

    procedure FormCreate(Sender: TObject);
    procedure LanguageBtnClick(Sender: TObject);

    procedure SlotTSChange(Sender: TObject; NewTab: Integer; var AllowChange: Boolean);

    procedure TypeCBChange(Sender: TObject);
    procedure BaseCBChange(Sender: TObject);
    procedure BaseCBKeyPress(Sender: TObject; var Key: Char);
    procedure IrqCBChange(Sender: TObject);
    procedure IrqCBKeyPress(Sender: TObject; var Key: Char);
    procedure InterfaceCBChange(Sender: TObject);
    procedure BindingCBChange(Sender: TObject);
    procedure CraitAddressEChange(Sender: TObject);
    procedure CraitAddressEKeyPress(Sender: TObject; var Key: Char);

    procedure IntEnabledCBClick(Sender: TObject);
    procedure IgnoreErrorCBClick(Sender: TObject);

    procedure DspSetupBtnClick(Sender: TObject);
    procedure TestBtnClick(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure ApplyBtnClick(Sender: TObject);
    procedure DefaultBtnClick(Sender: TObject);
    procedure AboutClick(Sender: TObject);
    procedure SetIgnoreErrorClick(Sender: TObject);
    procedure SetDelay1mksClick(Sender: TObject);
    procedure SetTimeoutClick(Sender: TObject);

  private
    { Private declarations }
  public
    procedure InitMaxSlot;
    procedure SetTabSet;
    procedure SetBindCB;
    procedure SetLanguage;
    procedure ShowAllVariable;
    { Public declarations }
  end;

var
    SetupForm:TSetupForm;

implementation
{$R *.DFM}
uses
    TestLTC, TestLCI, TestDlg, LBios, SetIE, DetDelay, About, DspSetup, Ini, LUtil, GlobVar, LCard_AD;

{* ************************************************************************* *}
procedure TSetupForm.InitMaxSlot;
var
    i:word;

Begin
    SlotTS.Tabs.Clear;
    BindingCB.Items.Clear;

    for i:=0 to MaxSlot do
    Begin
        SlotTS.Tabs.Add('');
        BindingCB.Items.Add('');
    End;
End;

{* ************************************************************************* *}
procedure TSetupForm.SetTabSet;
var
    i:word;

Begin
    for i:=0 to MaxSlot do SlotTS.Tabs[i]:=MyLoadStr(SlotTSTabs)+IntToStr(i)+'-'+BoardNames[SlotArray[i].BoardType];
    SlotTS.Tabs[CurrSlot]:=MyLoadStr(SlotTSTabs)+IntToStr(CurrSlot)+'-'+BoardNames[ThisSlot.BoardType];
End;

{* ************************************************************************* *}
procedure TSetupForm.SetBindCB;
var
    i        :word;
    SaveIndex:integer;

Begin
    SaveIndex:=BindingCB.ItemIndex;
    for i:=0 to MaxSlot do BindingCB.Items[i]:=MyLoadStr(BindingCBItems)+IntToStr(i);
    BindingCB.ItemIndex:=SaveIndex;
End;

{* ************************************************************************* *}
procedure TSetupForm.SetLanguage;
Begin
    if Language then
    Begin
        Multi:=$8000;
        LanguageBtn.Caption:='Russian';
    End else
    Begin
        Multi:=$0000;
        LanguageBtn.Caption:='English';
    End;
    LanguageBtn.Hint       :='Language Change';

    SetupForm.Caption      :=MyLoadStr(SetupFormCaption);

    SetBindCB;

    FirstPanel.Caption     :=MyLoadStr(FirstPanelCaption);
    LWinPanel.Caption      :=MyLoadStr(LWinPanelCaption);
    CommonPanel.Caption    :=MyLoadStr(CommonPanelCaption);
    PlatyPanel.Caption     :=MyLoadStr(PlatyPanelCaption);

    SetTabSet;
    SlotTS.Hint            :=MyLoadStr(SlotTSHint);

    TypeLab.Caption        :=MyLoadStr(TypeLabCaption);
    TypeCB.Hint            :=MyLoadStr(TypeCBHint);
    BaseLab.Caption        :=MyLoadStr(BaseLabCaption);
    BaseCB.Hint            :=MyLoadStr(BaseCBHint);
    IrqLab.Caption         :=MyLoadStr(IrqLabCaption);
    IrqCB.Hint             :=MyLoadStr(IrqCBHint);
    InterfaceLab.Caption   :=MyLoadStr(InterfaceLabCaption);
    InterfaceCB.Hint       :=MyLoadStr(InterfaceCBHint);
    BindingLab.Caption     :=MyLoadStr(BindingLabCaption);
    BindingCB.Hint         :=MyLoadStr(BindingCBHint);

    CraitAddressLab.Caption:=MyLoadStr(CraitAddressLabCaption);
    CraitAddressE.Hint     :=MyLoadStr(CraitAddressEHint);

    IntEnabledCB.Caption   :=MyLoadStr(IntEnabledCBCaption);
    IntEnabledCB.Hint      :=MyLoadStr(IntEnabledCBHint);
    IgnoreErrorCB.Caption  :=MyLoadStr(IgnoreErrorCBCaption);
    IgnoreErrorCB.Hint     :=MyLoadStr(IgnoreErrorCBHint);

    DspSetupBtn.Caption    :=MyLoadStr(DspSetupBtnCaption);
    DspSetupBtn.Hint       :=MyLoadStr(DspSetupBtnHint);
    TestBtn.Caption        :=MyLoadStr(TestBtnCaption);
    TestBtn.Hint           :=MyLoadStr(TestBtnHint);
    OkBtn.Caption          :=MyLoadStr(OkBtnCaption);
    OkBtn.Hint             :=MyLoadStr(OkBtnHint);
    CancelBtn.Caption      :=MyLoadStr(CancelBtnCaption);
    CancelBtn.Hint         :=MyLoadStr(CancelBtnHint);
    HelpBtn.Caption        :=MyLoadStr(HelpBtnCaption);
    HelpBtn.Hint           :=MyLoadStr(HelpBtnHint);
    ApplyBtn.Caption       :=MyLoadStr(ApplyBtnCaption);
    ApplyBtn.Hint          :=MyLoadStr(ApplyBtnHint);
    DefaultBtn.Caption     :=MyLoadStr(DefaultBtnCaption);
    DefaultBtn.Hint        :=MyLoadStr(DefaultBtnHint);
End;

{* ************************************************************************* *}
procedure TSetupForm.ShowAllVariable;
var
    i:word;

Begin
    IntEnabledCB.Checked:=ThisIntEnabled;
    IgnoreErrorCB.Checked:=ThisIgnoreError;

    with ThisSlot do
    Begin
        TypeCB.ItemIndex       :=BoardType;
        DspSetupBtn.Visible    :=BoardType in ADSPBoards;
        TestBtn.Visible        :=BoardType<>NO_BOARD;
        BaseCB.Text            :=IntToHex(BoardBase, 0);
        BaseCB.Visible         :=True;
        BaseLab.Visible        :=True;
        IrqCB.Text             :=IntToStr(BoardIrq);
        IrqCB.Visible          :=True;
        IrqLab.Visible         :=True;
        InterfaceCB.Visible    :=False;
        InterfaceLab.Visible   :=False;
        BindingCB.Visible      :=False;
        BindingLab.Visible     :=False;
        CraitAddressE.Visible  :=False;
        CraitAddressLab.Visible:=False;

        {  Irq      }
        {      Irq }
        IrqCB.Items.Clear;
        BaseCB.Items.Clear;
        case BoardType of

            L154,
            L164:
            Begin
                IrqCB.Items.Add('3');
                IrqCB.Items.Add('4');
                IrqCB.Items.Add('5');
                IrqCB.Items.Add('6');

                BaseCB.Items.Add('300');
                BaseCB.Items.Add('310');
                BaseCB.Items.Add('330');
                BaseCB.Items.Add('340');
            End;

            L241:
            Begin
                IrqCB.Items.Add('2');
                IrqCB.Items.Add('3');
                IrqCB.Items.Add('4');
                IrqCB.Items.Add('5');

                BaseCB.Items.Add('308');
                BaseCB.Items.Add('318');
                BaseCB.Items.Add('338');
                BaseCB.Items.Add('348');
            End;

            E330:
            Begin
                InterfaceCB.ItemIndex:=BoardInterface;
                InterfaceCB.Visible  :=True;
                InterfaceLab.Visible :=True;

                IrqCB.Items.Add('7');
                IrqCB.Items.Add('5');

                BaseCB.Items.Add('378');
                BaseCB.Items.Add('278');
                BaseCB.Items.Add('3BC');
            End;

            CRAIT:
            Begin
                InterfaceCB.ItemIndex:=BoardInterface;
                InterfaceCB.Visible  :=True;
                InterfaceLab.Visible :=True;

                if BoardInterface=SERIAL_INTERFACE then
                Begin
                    IrqCB.Items.Add('11');
                    IrqCB.Items.Add('10');

                    BaseCB.Items.Add('300');
                    BaseCB.Items.Add('310');
                    BaseCB.Items.Add('320');
                    BaseCB.Items.Add('330');

                    BindingCB.ItemIndex    :=Binding;
                    BindingCB.Visible      :=True;
                    BindingLab.Visible     :=True;
                    CraitAddressE.Text     :=IntToStr(CraitAddress);
                    CraitAddressE.Visible  :=True;
                    CraitAddressLab.Visible:=True;
                    IrqCB.Visible          :=False;
                    IrqLab.Visible         :=False;
                    BaseCB.Visible         :=False;
                    BaseLab.Visible        :=False;
                End else
                Begin
                    IrqCB.Items.Add('7');
                    IrqCB.Items.Add('5');

                    BaseCB.Items.Add('378');
                    BaseCB.Items.Add('278');
                    BaseCB.Items.Add('3BC');
                End;
            End;

            L1250:
            Begin
                IrqCB.Items.Add('11');
                IrqCB.Items.Add('10');

                BaseCB.Items.Add('300');
                BaseCB.Items.Add('310');
                BaseCB.Items.Add('330');
                BaseCB.Items.Add('340');
                BaseCB.Items.Add('380');
            End;

            L750,
            NO_BOARD:
            Begin
                IrqCB.Items.Add('11');

                BaseCB.Items.Add('300');

                BaseCB.Visible :=False;
                BaseLab.Visible:=False;
                IrqCB.Visible  :=False;
                IrqLab.Visible :=False;
            End;

            Unknown:
            Begin
                IrqCB.Items.Add('11');
                IrqCB.Items.Add('7');
                IrqCB.Items.Add('10');
                IrqCB.Items.Add('5');

                BaseCB.Items.Add('300');
                BaseCB.Items.Add('378');
                BaseCB.Items.Add('310');
                BaseCB.Items.Add('330');
                BaseCB.Items.Add('340');
                BaseCB.Items.Add('278');
                BaseCB.Items.Add('3BC');

                InterfaceCB.ItemIndex  :=BoardInterface;
                InterfaceCB.Visible    :=True;
                InterfaceLab.Visible   :=True;
                BindingCB.ItemIndex    :=Binding;
                BindingCB.Visible      :=True;
                BindingLab.Visible     :=True;
                CraitAddressE.Text     :=IntToStr(CraitAddress);
                CraitAddressE.Visible  :=True;
                CraitAddressLab.Visible:=True;
            End;
         else
            Begin
                IrqCB.Items.Add('11');
                IrqCB.Items.Add('10');

                BaseCB.Items.Add('300');
                BaseCB.Items.Add('310');
                BaseCB.Items.Add('330');
                BaseCB.Items.Add('340');
            End;
        End;
    End;
End;

{* ************************************************************************* *}
procedure TSetupForm.BaseCBKeyPress(Sender: TObject; var Key: Char);
begin
    Key:=UpCase(Key);
    if not (Key in [#8, '0'..'9', 'A'..'F']) then Key:=#27;
end;

{* ************************************************************************* *}
procedure TSetupForm.IrqCBKeyPress(Sender: TObject; var Key: Char);
var
    s:string;

begin
    if Key in ['0'..'9'] then
    Begin
        with IrqCB do
        Begin
            s:=Text;
            case SelStart of
                0:
                Begin
                    case Length(s) of
                        1:
                            if Key+s[1]>'15' then Key:=#27;
                        2:
                        Begin
                            s[1]:=Key;
                            if s<'16' then
                            Begin
                                Text:=s;
                                SelStart:=1;
                            End;
                        End;
                    End;
                End;
                1:
                Begin
                    case Length(s) of
                        1:
                            if s[1]+Key>'15' then Key:=#27;
                        2:
                        Begin
                            s[2]:=Key;
                            if s<'16' then
                            Begin
                                Text:=s;
                                SelStart:=1;
                            End;
                        End;
                    End;
                End;
            End;
        End;
    End else
    Begin
        if Key<>#8 then Key:=#27;
    End;
end;

{* ************************************************************************* *}
procedure TSetupForm.CraitAddressEKeyPress(Sender: TObject; var Key: Char);
var
    s:string;

begin
    if Key in ['0'..'9'] then
    Begin
        with CraitAddressE do
        Begin
            s:=Text;
            case SelStart of
                0:
                Begin
                    case Length(s) of
                        1:
                            if Key+s[1]>'63' then Key:=#27;
                        2:
                        Begin
                            s[1]:=Key;
                            if s<'64' then
                            Begin
                                Text:=s;
                                SelStart:=1;
                            End;
                        End;
                    End;
                End;
                1:
                Begin
                    case Length(s) of
                        1:
                            if s[1]+Key>'63' then Key:=#27;
                        2:
                        Begin
                            s[2]:=Key;
                            if s<'64' then
                            Begin
                                Text:=s;
                                SelStart:=1;
                            End;
                        End;
                    End;
                End;
            End;
        End;
    End else
    Begin
        if Key<>#8 then Key:=#27;
    End;
end;

{* ************************************************************************* *}
procedure TSetupForm.FormCreate(Sender: TObject);
var
    i:word;

begin
    ReadIniSettings;          {    lcard_ad.ini   }
    for i:=FirstBoard to LastBoard do TypeCB.Items.Add(BoardNames[i]);
    for i:=FirstInterface to LastInterface do InterfaceCB.Items.Add(InterfaceNames[i]);

    InitMaxSlot;
    SlotTS.TabIndex:=0;
    SetLanguage;
    SET_ERROR_HANDLER(@MyErrorHandler);
    SET_TIMEOUT(2000);
end;

{* ************************************************************************* *}
procedure TSetupForm.LanguageBtnClick(Sender: TObject);
begin
    Language:=not Language;
    SetLanguage;
end;

{* ************************************************************************* *}
procedure TSetupForm.SlotTSChange(Sender: TObject; NewTab: Integer; var AllowChange: Boolean);
begin
    if ApplyBtn.Enabled then
    Begin
        case MessageDlg(Format(MyLoadStr(SaveChangesConfirmation), [CurrSlot]),
                        mtConfirmation, [mbYes, mbNo, mbCancel, mbHelp], 0) of

            mrYes:
            Begin
                ApplyBtnClick(Sender);
            End;

            mrCancel:
            Begin
                AllowChange:=False;
                Exit;
            End;
        End;
    End;

    CurrSlot:=NewTab;
    DefaultBtnClick(Sender);
end;

{* ************************************************************************* *}
procedure TSetupForm.TypeCBChange(Sender: TObject);
begin
    ThisSlot.BoardType:=TypeCB.ItemIndex;
    ShowAllVariable;
    if ThisSlot.BoardType=E330 then InterfaceCB.ItemIndex:=EPP_INTERFACE;
    case ThisSlot.BoardType of
        NO_BOARD:;
        L750:;
        Unknown:;
    else
        with IrqCB do if Items.IndexOf(Text)=-1 then ItemIndex:=0;
        with BaseCB do if Items.IndexOf(Text)=-1 then ItemIndex:=0;
    End;
    IrqCB.OnChange(Sender);
    BaseCB.OnChange(Sender);
    InterfaceCBChange(Sender);
    {    TabSet }
    SetTabSet;
    {   BIOS      }
    with ThisSlot do BiosName:=ChangeFileExt(DefaultBiosName[BoardType], '');
    ApplyBtn.Enabled:=SlotCompare;
end;

{* ************************************************************************* *}
procedure TSetupForm.IrqCBChange(Sender: TObject);
begin
    if IrqCB.Text='' then IrqCB.Text:='5';
    ThisSlot.BoardIrq:=StrToInt(IrqCB.Text);
    ApplyBtn.Enabled:=SlotCompare;
end;

{* ************************************************************************* *}
procedure TSetupForm.BaseCBChange(Sender: TObject);
begin
    if BaseCB.Text='' then BaseCB.Text:='378';
    ThisSlot.BoardBase:=StrToInt('$'+BaseCB.Text);
    ApplyBtn.Enabled:=SlotCompare;
end;

{* ************************************************************************* *}
procedure TSetupForm.InterfaceCBChange(Sender: TObject);
begin
{ ???????????????? }
    if InterfaceCB.ItemIndex=-1 then InterfaceCB.ItemIndex:=0;
    ThisSlot.BoardInterface:=InterfaceCB.ItemIndex;
    ApplyBtn.Enabled:=SlotCompare;
    ShowAllVariable;
end;

{* ************************************************************************* *}
procedure TSetupForm.BindingCBChange(Sender: TObject);
begin
    ThisSlot.Binding:=BindingCB.ItemIndex;
    ApplyBtn.Enabled:=SlotCompare;
end;

{* ************************************************************************* *}
procedure TSetupForm.CraitAddressEChange(Sender: TObject);
begin
    if CraitAddressE.Text='' then CraitAddressE.Text:='0';
    ThisSlot.CraitAddress:=StrToInt(CraitAddressE.Text);
    ApplyBtn.Enabled:=SlotCompare;
end;

{* ************************************************************************* *}
procedure TSetupForm.IntEnabledCBClick(Sender: TObject);
begin
    ThisIntEnabled:=IntEnabledCB.Checked;
    ApplyBtn.Enabled:=SlotCompare;
end;

{* ************************************************************************* *}
procedure TSetupForm.IgnoreErrorCBClick(Sender: TObject);
begin
    ThisIgnoreError:=IgnoreErrorCB.Checked;
    ApplyBtn.Enabled:=SlotCompare;
end;

{* ************************************************************************* *}
procedure TSetupForm.DspSetupBtnClick(Sender: TObject);
begin
    if ApplyBtn.Enabled then
    Begin
        case MessageDlg(Format(MyLoadStr(SaveChangesConfirmation), [CurrSlot]),
                        mtConfirmation, [mbYes, mbNo, mbCancel, mbHelp], 0) of

            mrNo:     DefaultBtnClick(Sender);
            mrYes:    ApplyBtnClick(Sender);
            mrCancel: Exit;
        End;
    End;

    DspSetupForm.ShowModal;
end;

{* ************************************************************************* *}
procedure TSetupForm.TestBtnClick(Sender: TObject);
var
    i       :word;
    SaveSlot:integer;
Begin

    if (ThisSlot.BoardType=CRAIT) and (ThisSlot.BoardInterface=SERIAL_INTERFACE) then
    Begin
        if ThisSlot.Binding>=MaxSlot then Exit;
        SaveSlot:=SlotTS.TabIndex;
        SlotTS.TabIndex:=ThisSlot.Binding;
        if ThisSlot.BoardType<>LCI01 then Exit;
        LoadBoardBios;
        SlotTS.TabIndex:=SaveSlot;
    End;

    with ThisSlot do
    Begin
        {  BIOS   }
        if LoadBoardBios then
        Begin
            case BoardType of
                LCI01: TestLCIForm.ShowModal;
                CRAIT: TestLTCForm.ShowModal;
            else
                TestBoardForm.ShowModal;
            End;
        End;
    End;
End;

{* ************************************************************************* *}
procedure TSetupForm.ApplyBtnClick(Sender: TObject);
begin
    SlotArray[CurrSlot]:=ThisSlot;
    IntEnabled :=ThisIntEnabled;
    IgnoreError:=ThisIgnoreError;
    WriteIniSettings;
    ApplyBtn.Enabled:=SlotCompare;
    ShowAllVariable;
end;

{* ************************************************************************* *}
procedure TSetupForm.OkBtnClick(Sender: TObject);
begin
    ApplyBtnClick(Sender);
    CancelBtnClick(Sender);
end;

{* ************************************************************************* *}
procedure TSetupForm.CancelBtnClick(Sender: TObject);
begin
    Close;
end;

{* ************************************************************************* *}
procedure TSetupForm.DefaultBtnClick(Sender: TObject);
Begin
    ThisSlot:=SlotArray[CurrSlot];
    ThisIntEnabled :=IntEnabled;
    ThisIgnoreError:=IgnoreError;
    ApplyBtn.Enabled:=SlotCompare;
    ShowAllVariable;
End;

{* ************************************************************************* *}
procedure TSetupForm.AboutClick(Sender: TObject);
Begin
    if MessageDlg('Do You Love L-Card', mtConfirmation, [mbYes, mbNo, mbHelp], 0)=mrYes then AboutBox.ShowModal;
End;

{* ************************************************************************* *}
procedure TSetupForm.SetTimeoutClick(Sender: TObject);
Begin
 {dfgdf}
End;

{* ************************************************************************* *}
procedure TSetupForm.SetIgnoreErrorClick(Sender: TObject);
Begin
    SetIgnoreErrorForm.ShowModal;
End;

{* ************************************************************************* *}
procedure TSetupForm.SetDelay1mksClick(Sender: TObject);
Begin
    DetDelayForm.ShowModal;
End;

End.

