unit TestLTC;
{$IFNDEF DEBUG}
{$A+,B-,D-,F-,G+,I-,K+,L-,N+,P+,Q-,R-,S-,T+,V-,W-,X+,Y-}
{$ENDIF}

interface
uses
    SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
    Forms, Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TTestLTCForm = class(TForm)
    TestLTCPanel: TPanel;
    MemoryStateLab: TLabel;
    MemoryStateE: TEdit;
    MemoryPMStateLab: TLabel;
    MemoryPMStateE: TEdit;
    ModuleListBox: TListBox;
    OkBtn: TBitBtn;
    TestLTCTimer: TTimer;
    procedure FormActivate(Sender: TObject);
    procedure ModuleListBoxDblClick(Sender: TObject);
    procedure TestLTCTimerTimer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    procedure SetLanguage;
    { Public declarations }
  end;

var
    TestLTCForm: TTestLTCForm;

implementation
uses
    LUtil, GlobVar, LCard_AD;

{$R *.DFM}

const
    MemoryStates_CC:array[0..4] of string[10] = ('No', '8K word', '32K word', '128 K word', '???');
    MemoryPMStates :array[0..1] of string[10] = ('No', '8K word');

{* ************************************************************************* *}
procedure TTestLTCForm.SetLanguage;
Begin
    TestLTCForm.Caption     :=MyLoadStr(TestLTCFormCaption);
    TestLTCPanel.Caption    :=MyLoadStr(TestLTCPanelCaption);
    MemoryStateLab.Caption  :=MyLoadStr(MemoryStateLabCaption);
    MemoryStateE.Hint       :=MyLoadStr(MemoryStateEHint);
    MemoryPMStateLab.Caption:=MyLoadStr(MemoryPMStateLabCaption);
    MemoryPMStateE.Hint     :=MyLoadStr(MemoryPMStateEHint);
End;

{* ************************************************************************* *}
procedure TTestLTCForm.FormActivate(Sender: TObject);
var
    i         :word;
    s         :string;
    ModuleCode:word;

begin
    SetLanguage;

    i:=MEMORY_STATE_CC;
    MemoryStateE.Text:=MemoryStates_CC[i];
    i:=MEMORY_PM_STATE_CC;
    MemoryPMStateE.Text:=MemoryPMStates[i];

    ModuleListBox.Items.Clear;
    for i:=0 to 15 do
    Begin
        ModuleCode:=READ_FLASH_CC(i, 0);
        if (ModuleCode=0) or (ModuleCode=$FFFF) then s:=MyLoadStr(ModuleListBoxItemsR) else s:=IntToStr(ModuleCode);
        ModuleListBox.Items.Add(MyLoadStr(ModuleListBoxItemsL)+IntToStr(i)+' - '+s);
    End;
end;

{* ************************************************************************* *}
procedure TTestLTCForm.ModuleListBoxDblClick(Sender: TObject);
var
    s     :string;
    Buffer:array[0..255] of char;

Begin
    s:=ModuleListBox.Items[ModuleListBox.ItemIndex];
    s:=Copy(s, Pos(' - ', s)+3, Length(s)-Pos(' - ', s)-2);
    StrPCopy(Buffer, ExtractFilePath(ParamStr(0))+s+'.EXE');
    TestLTCTimer.Tag:=WinExec(Buffer, SW_SHOWMAXIMIZED);
    if TestLTCTimer.Tag>=32 then
    Begin
        ModuleListBox.Enabled:=False;
        OkBtn.Enabled:=False;
        TestLTCTimer.Enabled:=True;
    End;
End;

{* ************************************************************************* *}
procedure TTestLTCForm.TestLTCTimerTimer(Sender: TObject);
Begin
    if GetModuleUsage(TestLTCTimer.Tag)=0 then
    Begin
        TestLTCTimer.Enabled:=False;
        OkBtn.Enabled:=True;
        ModuleListBox.Enabled:=True;
    End;
End;

{* ************************************************************************* *}
procedure TTestLTCForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
Begin
    CanClose:=Not TestLTCTimer.Enabled;
End;

End.

